/*
 * Copyright 2013-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You may not use this file except in compliance with
 * the License. A copy of the License is located at
 * 
 * http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions
 * and limitations under the License.
 */
package com.amazonaws.services.medialive.model;

import java.io.Serializable;
import javax.annotation.Generated;
import com.amazonaws.protocol.StructuredPojo;
import com.amazonaws.protocol.ProtocolMarshaller;

/**
 * Placeholder documentation for VideoSelectorSettings
 * 
 * @see <a href="http://docs.aws.amazon.com/goto/WebAPI/medialive-2017-10-14/VideoSelectorSettings" target="_top">AWS
 *      API Documentation</a>
 */
@Generated("com.amazonaws:aws-java-sdk-code-generator")
public class VideoSelectorSettings implements Serializable, Cloneable, StructuredPojo {

    private VideoSelectorPid videoSelectorPid;

    private VideoSelectorProgramId videoSelectorProgramId;

    /**
     * @param videoSelectorPid
     */

    public void setVideoSelectorPid(VideoSelectorPid videoSelectorPid) {
        this.videoSelectorPid = videoSelectorPid;
    }

    /**
     * @return
     */

    public VideoSelectorPid getVideoSelectorPid() {
        return this.videoSelectorPid;
    }

    /**
     * @param videoSelectorPid
     * @return Returns a reference to this object so that method calls can be chained together.
     */

    public VideoSelectorSettings withVideoSelectorPid(VideoSelectorPid videoSelectorPid) {
        setVideoSelectorPid(videoSelectorPid);
        return this;
    }

    /**
     * @param videoSelectorProgramId
     */

    public void setVideoSelectorProgramId(VideoSelectorProgramId videoSelectorProgramId) {
        this.videoSelectorProgramId = videoSelectorProgramId;
    }

    /**
     * @return
     */

    public VideoSelectorProgramId getVideoSelectorProgramId() {
        return this.videoSelectorProgramId;
    }

    /**
     * @param videoSelectorProgramId
     * @return Returns a reference to this object so that method calls can be chained together.
     */

    public VideoSelectorSettings withVideoSelectorProgramId(VideoSelectorProgramId videoSelectorProgramId) {
        setVideoSelectorProgramId(videoSelectorProgramId);
        return this;
    }

    /**
     * Returns a string representation of this object; useful for testing and debugging.
     *
     * @return A string representation of this object.
     *
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("{");
        if (getVideoSelectorPid() != null)
            sb.append("VideoSelectorPid: ").append(getVideoSelectorPid()).append(",");
        if (getVideoSelectorProgramId() != null)
            sb.append("VideoSelectorProgramId: ").append(getVideoSelectorProgramId());
        sb.append("}");
        return sb.toString();
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;

        if (obj instanceof VideoSelectorSettings == false)
            return false;
        VideoSelectorSettings other = (VideoSelectorSettings) obj;
        if (other.getVideoSelectorPid() == null ^ this.getVideoSelectorPid() == null)
            return false;
        if (other.getVideoSelectorPid() != null && other.getVideoSelectorPid().equals(this.getVideoSelectorPid()) == false)
            return false;
        if (other.getVideoSelectorProgramId() == null ^ this.getVideoSelectorProgramId() == null)
            return false;
        if (other.getVideoSelectorProgramId() != null && other.getVideoSelectorProgramId().equals(this.getVideoSelectorProgramId()) == false)
            return false;
        return true;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int hashCode = 1;

        hashCode = prime * hashCode + ((getVideoSelectorPid() == null) ? 0 : getVideoSelectorPid().hashCode());
        hashCode = prime * hashCode + ((getVideoSelectorProgramId() == null) ? 0 : getVideoSelectorProgramId().hashCode());
        return hashCode;
    }

    @Override
    public VideoSelectorSettings clone() {
        try {
            return (VideoSelectorSettings) super.clone();
        } catch (CloneNotSupportedException e) {
            throw new IllegalStateException("Got a CloneNotSupportedException from Object.clone() " + "even though we're Cloneable!", e);
        }
    }

    @com.amazonaws.annotation.SdkInternalApi
    @Override
    public void marshall(ProtocolMarshaller protocolMarshaller) {
        com.amazonaws.services.medialive.model.transform.VideoSelectorSettingsMarshaller.getInstance().marshall(this, protocolMarshaller);
    }
}
